\section{Connect PyCharm to job allocation resources}
\label{sec:connect_to_job}

For most simple development tasks, using the login nodes on OzStar will prove sufficient. However, at times, some debugging tasks may require access to more resources that are only available through a job allocation.\\

The steps required to do this are:
\begin{enumerate}
    \item get a remote job allocation
    \item connect that assigned resource to the login node
    \item connect local interpreter to assigned resource
\end{enumerate} 

and I'll discuss each of the points above in detail now.

\subsection{Get a remote job allocation}
\label{sec:get_remote_job}

In order to request any resource on OzStar, you must first login. Once you've logged in you can make a request. For example, let's say I need a single thread with 12gb of RAM assigned to me for 4 hours, I would then make the following request:\\

{\it sinteractive --mem=12gb --time=04:00:00} \\

After the request is granted, I would have to identify the location of the resource, ie. on which machine have I been granted time on. In this instance, I was granted access on {\it \bf john26}. I know this because my location changed from {\it \bf acodorea@farnakle1} to {\it \bf acodorea@john26} \\

\subsection{Connect an assigned resource to the login node}
Now that I have a job allocation assigned to me and I know on which machine it was granted, I need to connect that machine and job resource to the login node. In order to accomplish this, I will port forward from the login node to the machine on which the resource has been allocated, in this case {\it \bf john26}. \\

In a new terminal window, login to OzStar and run the following command:\\

{\it ssh -L 2222:john26:22 acodorea@ozstar.swin.edu.au} \\

You can now test this process by connecting to port 2222 on the login nodes. If you run: \\

{\it ssh -p 2222 acodorea@localhost} \\

on one of the login nodes, you should now be taken to the machine on which your resource has been allocated.

\begin{tcolorbox}[colback=yellow!10!white ,
colframe=white!20!black]
	
	\begin{center}
		\textsc{Please Note:}
	\end{center}
	
	In the above example, you need to substitute <acodorea> with <your\_username> on OzStar. I've also chosen port 2222 to act as the port forwarding location because it was an easy number to remember as 22 is the default login port number. You can choose a different one, but remember to keep it consistent through the process. \\
	
\end{tcolorbox}

\subsection{Connect local interpreter to assigned resource}

This particular step only needs to be done once but remember to keep the port number through which you forward on the remote local host consistent (ie. if you used 2222 then you can just go with these instructions). \\

The goal is to have a remote interpreter that connects through the OzStar login nodes but uses the resources requested in section \ref{sec:get_remote_job}. If you run into any issues, you can go back and review section \ref{sec:connect} which describes this process in further detail. I will not discuss the synchronisation steps discussed in section \ref{sec:sync} but you can go back to that section. The same instructions apply. \\

The abbreviated set-up instructions are:

\begin{enumerate}
     
\item in settings go to project interpreter tab

\item click on wheel icon to the right of the default interpreter and click 'Add'

\item select ssh remote interpreter

\item host will be: localhost

\item port will be: 2222

\item username: OzStar username\footnote{{\it acodorea for me}}

\item click Next and enter your OzStar username password\footnote{this will be saved so you don't have to set up a key pair}

\item click on the three dots to the left of the Interpreter option which will bring up a remote view of the OzStar file system. Navigate to and select your python executable\footnote{I've found that navigating and clicking on the executable works best rather than just putting in the location}. If you don't know where the interpreter is located, you can find it by using ‘which python’ command once you login to OzStar. \\

\end{enumerate}

Ok, so now you should be able to access the remote resources through your local PyCharm distribution. One way you can test this without PyCharm is by running a {\it Hello\_world.py} example in a remote location. For me, that would look something like this: \\

{\it ssh://acodorea@localhost:2222/home/acodorea/miniconda3/bin/python -u /fred/oz077/alexc/sandbox/Hello\_world.py \\
}

which outputs: \\

{\it Hello world!}



